include \masm32\MasmBasic\MasmBasic.inc	; version 6 April 2011, http://www.masm32.com/board/index.php?topic=12460.0
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

AlgoCt = 0
PrintCycles MACRO algo, avrg
	AlgoCt = AlgoCt + 1
	push eax
	.if eax>100000
		shr eax, 10
		Print Str$("%i\tkCycles", eax)
	.else
		Print Str$("%i\tcycles", eax)
	.endif
	fild dword ptr [esp]
	mov dword ptr [esp], Elements
	fidiv dword ptr [esp]
	fistp dword ptr [esp]
	pop eax
	Print Str$(", \t%i cpe for &algo&\n", eax)
ENDM

.data?
cycount	dd 20 dup(?)	; global cycle count, for calculating avg cycles per element
		Init
		push 1
		call ShowCpu			; print brand string and SSE level
		SleepMs =  	50		; test if anything changes when changing this
		ShowGaps=	0
		ShowRes=  	0
		Elements=  	160000
	LOOP_COUNT = 1600000/Elements
	PrintLine Str$("Initial loop count is %i", LOOP_COUNT), Chr$(59), " cpe=cycles per array element"
	Let esi= New$(4*Elements)	; source array: we'll put random numbers here
	Let edi= New$(4*Elements)	; make a copy to base timings on identical data
	mov ecx, Elements
	ffree st(7)
	.Repeat
		Rand(-1.23456789E9, 1.23456789E9)	; put random value on FPU
		fstp REAL4 ptr [esi+4*ecx]		; save to array
	dec ecx
	.Until Sign?
	REPEAT 8
		Print Str$("\n** %i elements:\n", Elements)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		   invoke MbCopy, edi, esi, 4*Elements	; load a fresh unsorted copy
		   invoke nrQsortA, edi, Elements
		counter_end
		PrintCycles nrQsortA
		invoke Sleep, SleepMs
		finit		; CombSortA needs a virgin FPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		   invoke MbCopy, edi, esi, 4*Elements
		   invoke CombSortA, edi, Elements
		counter_end
		PrintCycles CombSortA
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		   invoke MbCopy, edi, esi, 4*Elements
		   ArraySort edi:Elements
		counter_end
		PrintCycles ArraySort, avrg
		Elements=Elements/2
		LOOP_COUNT=LOOP_COUNT*2
	ENDM
	Inkey "Press any key"
	Exit debug
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp
end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Errline	0
